<!DOCTYPE html>
<html>

  <head>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="My personal website">
    <meta name="author" content="Alexandre Acsensi">

    <title>Networking and communications</title>

    <link href="../../css/bootstrap.min.css" rel="stylesheet"> <!-- Bootstrap core CSS -->
    <link href="../../css/main.css" rel="stylesheet"> <!-- Custom styles for this template -->
    <link href="https://fonts.googleapis.com/css?family=Roboto:100,100i,300,300i,400,400i,500,500i,700,700i,900,900i" rel="stylesheet">

    <link rel="shortcut icon" type="image/png" href="../../img/aavlogo-black.png">

  </head>

  <body>

    <section id="mdeft1" >
      <div class="container">
        <div class="row">
          <div class="col-lg-8 mx-auto">
            <h2>Networking and communications</h2>
            <u><a class="text_black" href="http://academy.cba.mit.edu/classes/networking_communications/index.html" target="_blank"><h6>FabAcademy networking and communications</h6></a> </u>
            <u><a class="text_black" href="http://fab.academany.org/2019/labs/barcelona/local/wa/week13/" target="_blank"><h6>FabBarcelona networking and communications</h6></a> </u>
            <br>
            <p>
            I did this assigment with Laura Álvarez, Adriana Tamargo and Nico Viollier.
            <br><br>
            The aim of this week was to learn how to make wireless communications between two boards.
            We followed <u><a class="text_black" href="https://hackmd.io/s/B15x5dn9V#OTA-communication" target="_blank">
              this class.</a> </u>
            <br>
            And also
            <u> <a class="text_black" target="_blank" href="https://howtomechatronics.com/tutorials/arduino/how-to-build-an-arduino-wireless-network-with-multiple-nrf24l01-modules/"> this tutorial.</a> </u>

            </p>
            <br>
            <ul>
              <li> <u> <a class="text_black" href="#a"> Making the circuit</a> </li> </u>
              <li> <u> <a class="text_black" href="#b"> Coding the boards</a> </li> </u>
              <li> <u> <a class="text_black" target="_blank" href="files/w14files.zip" download> click to download the files</a> </li> </u>
            </ul>

            <br><br>

            <h5 id=a> Making the circuit </h5>
            <br>
            <p>
              For the networking and communications circuit we will use an arduino board + an NRF24.
              The NRF24 is a communication device to establish RF (Radio Frequency) communications between two or more points.
              <br>
              Following the diagram below show we prepared two points (I mean 2 x arduino + NRF24).
            </p>
            <br>
            <center><img src="files/W13_w.JPG" width="87%"></center>
            <p>The final result was this:</p>
            <br>
            <center><img src="files/W13_NFR24.jpeg" width="87%"></center>

            <br><br>

            <h5 id=b> Coding the boards </h5>
            <br>
            <p>
              To program the boards, the first step was to download the libraries of the NRF24, as shown in the following image:
            </p>
            <br>
            <center><img src="files/W13_l.JPG" width="87%"></center>
            <br>
            <p>
              Once this was done, we put the sender code on one board and the receiver code on another.
            </p>
            <i>sender code</i>
            <br>
            <code>
              #include < nRF24L01.h> <br>
              #include < RF24.h> <br>
              #include < RF24_config.h> <br>
              #include < SPI.h> <br>
              <br>
              const int pinCE = 9; <br>
              const int pinCSN = 10; <br>
              RF24 radio(pinCE, pinCSN); <br>
              const uint64_t pipe = 0xE8E8F0F0E1LL; <br>
              char data[16]="Hola mundo" ; <br>
               <br>
              void setup(void) <br>
              { <br>
                 radio.begin(); <br>
                 radio.openWritingPipe(pipe); <br>
              } <br>
                <br>
              void loop(void) <br>
              { <br>
                 radio.write(data, sizeof data); <br>
                 delay(1000); <br>
              }<br>
            </code>
            <br>
            <i>receiver code</i>
            <br>
            <code>
<br>              #include < nRF24L01.h>
    <br>          #include < RF24.h>
        <br>      #include < RF24_config.h>
            <br>  #include < SPI.h>
<br>
<br>              const int pinCE = 9;
<br>              const int pinCSN = 10;
<br>              RF24 radio(pinCE, pinCSN);
<br>              const uint64_t pipe = 0xE8E8F0F0E1LL;
<br>              char data[16];
<br>
<br>              void setup(void)
<br>              {
<br>                 Serial.begin(9600);
<br>                 radio.begin();
<br>                 radio.openReadingPipe(1,pipe);
<br>                 radio.startListening();
<br>              }
<br>
<br>              void loop(void)
<br>              {
<br>                 if (radio.available())
<br>                 {
<br>                    radio.read(data, sizeof data);
<br>                    Serial.println(data);
<br>                 }
<br>              }
            </code>
            <br>
            <br>
            <p>
              It worked! :)
            </p>
            <center><img src="files/13_4.gif" width="87%"></center>
            <br>
            <br>
            <i>longer charts</i>
            <br><br>
            <p>
              To play a bit more we tried to change the "Hello World" message to another one.
              Here arose the first problem arose, as you can see in the photo below not all the characters of our new sentence were sent.
            </p>
            <br>
            <center><img src="files/13_7.jpg" width="87%"></center>
            <br><br>

            <p>
              We discovered that the NRF24 can only send 32 bytes of information. Each character of the phrase being one byte.
              So, to fix the problem we divided the sentence into several information packets of 32 bytes each.
              The change in the code was this:
            </p>
            <br>
            <code>char data[16]="Hola mundo";</code>

            <br><br>
            <p>to</p>

            <code>char data[16]="Hola k ase Laura q tal con los Jordis?";</code>

            <br><br>
            <p>this not worked, and then finally this:</p>

            <code>
              char data[16]="Hola k ase Laura" ; <br>
              char data[16]="q tal con los Jordis?" ;
            </code>

            <br><br>

            <center><img src="files/13_11.jpg" width="87%"></center>

            <br><br>
            <i>password between boards</i>
            <br><br>
            <p>
              Then we analyze the code more deeply to understand more things.
              <br> This part:<br>
            </p>
            <code>
              const uint64_t pipe = 0xE8E8F0F0E1LL;
            </code>
            <br><br>
            <p>it's the password between the devices, and it has to be the same in both codes.
              <br>
              It can be changed by any password that is included in the ASCII nomenclature. So we tried another "47474747" and it worked
            </p>
            <br><br>
            <i>sending inputs and generating outputs in the other board</i>
            <br><br>
            <p>
              Finally to deepen more in the art of electronic communication we did the following:
              we added a LDR photoresistor to the arduino sender and a red led to the receiver. <br>
              We sent the signal from the first arduino to the second one, and if this light input was greater than 200 we turned on the red led.
              <br><br>
              This is the code for the receiver:
            </p>
            <br>
            <code>
              #include < nRF24L01.h>
<br>              #include < RF24.h>
<br>              #include < RF24_config.h>
<br>              #include < SPI.h>

<br>              const int pinCE = 9;
<br>              const int pinCSN = 10;
<br>              RF24 radio(pinCE, pinCSN);
<br>              const uint64_t pipe = 4747;

<br>              char data[4];

<br>              void setup(void)
<br>              {

<br>                 pinMode(6, OUTPUT);

<br>                 Serial.begin(9600);
<br>                 radio.begin();
<br>                 radio.openReadingPipe(1,pipe);
<br>                 radio.startListening();
<br>              }

<br>              void loop(void)
<br>              {
<br>                 if (radio.available())
<br>                 {
<br>                    radio.read(data, sizeof data);
<br>                    Serial.println(data);

<br>                    int c = (int)data;

<br>                       if (c > 200) {digitalWrite(6, HIGH);
<br>                        }
                 }

              }
            </code>
            <br><br>
            <iframe width="100%" height="400" src="https://www.youtube.com/embed/nWk7f3wqhLA" frameborder="0" autoplay muted loop></iframe>
            <br><br>
            <p>See you next week!!!</p>
            <br>
            <iframe src="https://giphy.com/embed/l1J3CbFgn5o7DGRuE" width="480" height="309" frameBorder="0" class="giphy-embed" allowFullScreen></iframe><p><a href="https://giphy.com/gifs/goodbye-see-ya-you-l1J3CbFgn5o7DGRuE">via GIPHY</a></p>



          </div>
        </div>
      </div>
    </section>

  </body>

</html>
